local _, addonTable = ...;
local fuFrame=Pig_Options_RF_TAB_5_UI
--任务界面扩展--------------------
local function RenwuFrame_Open()
	if QUESTS_DISPLAYED==6 then 
		UIPanelWindows["QuestLogFrame"] = {area = "override", pushable = 0, xoffset = -16, yoffset = 12, bottomClampOverride = 140 + 12, width = 714, height = 487, whileDead = 1}
		--任务界面扩展
		--缩放任务框架以匹配新纹理
		QuestLogFrame:SetWidth(714)
		QuestLogFrame:SetHeight(487)

		--任务日志标题移到中间
		QuestLogTitleText:ClearAllPoints();
		QuestLogTitleText:SetPoint("TOP", QuestLogFrame, "TOP", 0, -18);

		-- 任务详细说明移到右边，并增加高度
		QuestLogDetailScrollFrame:ClearAllPoints();
		QuestLogDetailScrollFrame:SetPoint("TOPLEFT", QuestLogListScrollFrame,"TOPRIGHT", 30, 0);
		QuestLogDetailScrollFrame:SetHeight(335);

		-- 任务目录增加高度
		QuestLogListScrollFrame:SetHeight(335);

		-- 增加可显示任务目录数
		local oldQuestsDisplayed = QUESTS_DISPLAYED;
		QUESTS_DISPLAYED = QUESTS_DISPLAYED + 16;
		for i = oldQuestsDisplayed + 1, QUESTS_DISPLAYED do
		    local button = CreateFrame("Button", "QuestLogTitle" .. i, QuestLogFrame, "QuestLogTitleButtonTemplate");
		    button:SetID(i);
		    button:Hide();
		    button:ClearAllPoints();
		    button:SetPoint("TOPLEFT", getglobal("QuestLogTitle" .. (i-1)), "BOTTOMLEFT", 0, 1);
		end
		--更换纹理
		local regions = { QuestLogFrame:GetRegions() }
		regions[3]:SetTexture("Interface\\QUESTFRAME\\UI-QuestLogDualPane-Left")
		regions[3]:SetSize(512,512)

		regions[4]:ClearAllPoints()
		regions[4]:SetPoint("TOPLEFT", regions[3], "TOPRIGHT", 0, 0)
		regions[4]:SetTexture("Interface\\QUESTFRAME\\UI-QuestLogDualPane-Right")
		regions[4]:SetSize(256,512)

		regions[5]:Hide()
		regions[6]:Hide()
		--调整放弃任务按钮大小位置
		QuestLogFrameAbandonButton:SetSize(110, 21)
		QuestLogFrameAbandonButton:SetText(ABANDON_QUEST_ABBREV)
		QuestLogFrameAbandonButton:ClearAllPoints()
		QuestLogFrameAbandonButton:SetPoint("BOTTOMLEFT", QuestLogFrame, "BOTTOMLEFT", 17, 54)
		--调整共享任务按钮大小
		QuestFramePushQuestButton:SetSize(100, 21)
		QuestFramePushQuestButton:SetText(SHARE_QUEST_ABBREV)
		QuestFramePushQuestButton:ClearAllPoints()
		QuestFramePushQuestButton:SetPoint("LEFT", QuestLogFrameAbandonButton, "RIGHT", -3, 0)
		-- 增加显示地图按钮
		local logMapButton = CreateFrame("Button", "logMapButton_UI", QuestLogFrame, "UIPanelButtonTemplate")
		logMapButton:SetText("显示地图")
		logMapButton:ClearAllPoints()
		logMapButton:SetPoint("LEFT", QuestFramePushQuestButton, "RIGHT", -3, 0)
		logMapButton:SetSize(100, 21)
		logMapButton:SetScript("OnClick", ToggleWorldMap)
		-- 调整没有任务文字提示位置
		QuestLogNoQuestsText:ClearAllPoints();
		QuestLogNoQuestsText:SetPoint("TOP", QuestLogListScrollFrame, 0, -90);
		--隐藏没有任务时纹理
		local txset = { EmptyQuestLogFrame:GetRegions();}
		txset[1]:Hide();
		txset[2]:Hide();
		txset[3]:Hide();
		txset[4]:Hide();

		--[[
		-- 移动没有任务时纹理
		local topOfs = 0.37;
		local topH = 256 * (1 - topOfs);

		local botCap = 0.83;
		local botH = 128 *  botCap;

		local xSize = 256 + 64;
		local ySize = topH + botH;

		local nxSize = QuestLogDetailScrollFrame:GetWidth() + 26;
		local nySize = QuestLogDetailScrollFrame:GetHeight() + 8;

		local function relocateEmpty(t, w, h, x, y)
		    local nx = x / xSize * nxSize - 10;
		    local ny = y / ySize * nySize + 8;
		    local nw = w / xSize * nxSize;
		    local nh = h / ySize * nySize;

		    t:SetWidth(nw);
		    t:SetHeight(nh);
		    t:ClearAllPoints();
		    t:SetPoint("TOPLEFT", QuestLogDetailScrollFrame, "TOPLEFT", nx, ny);
		end
		for _, t in ipairs(txset) do
		    if (t:IsObjectType("Texture")) then
		        local p = t:GetTexture();
		        if (type(p) == "string") then
		            p = p:match("-([^-]+)$");
		            if (p) then
		                if (p == "TopLeft") then
		                    t:SetTexCoord(0, 1, topOfs, 1);
		                    relocateEmpty(t, 256, topH, 0, 0);
		                elseif (p == "TopRight") then
		                    t:SetTexCoord(0, 1, topOfs, 1);
		                    relocateEmpty(t, 64, topH, 256, 0);
		                elseif (p == "BotLeft") then
		                    t:SetTexCoord(0, 1, 0, botCap);
		                    relocateEmpty(t, 256, botH, 0, -topH);
		                elseif (p == "BotRight") then
		                    t:SetTexCoord(0, 1, 0, botCap);
		                    relocateEmpty(t, 64, botH, 256, -topH);
		                else
		                    t:Hide();
		                end
		            end
		        end
		    end
		end
		]]--
	end
end
-- 显示任务等级
local function gengxinLVQR()
	local numEntries, numQuests = GetNumQuestLogEntries();	
	if (numEntries == 0) then return end
	
	local questIndex, questLogTitle, title, level, _, isHeader, questTextFormatted, questCheck, questCheckXOfs
	for i = 1, QUESTS_DISPLAYED, 1 do
		questIndex = i + FauxScrollFrame_GetOffset(QuestLogListScrollFrame);
		
		if (questIndex <= numEntries) then
			questLogTitle = _G["QuestLogTitle"..i]
			questCheck = _G["QuestLogTitle"..i.."Check"]
			title, level, _, isHeader = GetQuestLogTitle(questIndex)
			
			if (not isHeader) then
				questTextFormatted = format("  [%d] %s", level, title)
				questLogTitle:SetText(questTextFormatted)
				QuestLogDummyText:SetText(questTextFormatted)
			end
			questCheck:SetPoint("LEFT", questLogTitle, "LEFT", QuestLogDummyText:GetWidth()+24, 0);
		end  
	end
end
QuestLogFrame:HookScript('OnShow', function()
	QuestTT=C_Timer.NewTicker(0.01,gengxinLVQR)
end)
QuestLogFrame:HookScript('OnHide', function()
	QuestTT:Cancel()
end)
---------------------
fuFrame.Renwu = CreateFrame("CheckButton", nil, fuFrame, "ChatConfigCheckButtonTemplate");
fuFrame.Renwu:SetSize(30,32);
fuFrame.Renwu:SetPoint("TOPLEFT",fuFrame,"TOPLEFT",20,-80);
fuFrame.Renwu.Text:SetText("任务界面扩展");
fuFrame.Renwu.tooltip = "扩展任务界面为两列；左边任务列表，右边任务详情！";
fuFrame.Renwu:SetScript("OnClick", function (self)
	if self:GetChecked() then
		PIG['FramePlus']['ExtFrame_Renwu']="ON";
		RenwuFrame_Open();
	else
		PIG['FramePlus']['ExtFrame_Renwu']="OFF";
		Pig_Options_RLtishi_UI:Show()
	end
end);
--------
--========================================
--专业界面
local Width,Height = 32,32;
local Skill_List = {'烹饪', '急救', '裁缝', '熔炼', '工程学', '锻造', '附魔', '制皮', '炼金术',"珠宝加工"};
local Skill_List_1 = {'分解', '基础营火',"选矿"};
local function Skilllaqu()
	Skill_List_ON = {};
	Skill_List_1_ON = {};
	local _, _, tabOffset, numEntries = GetSpellTabInfo(1)
	for ii=1, #Skill_List do
		for i=tabOffset + 1, tabOffset + numEntries do
			local spellName, _ = GetSpellBookItemName(i, BOOKTYPE_SPELL)
			if spellName==Skill_List[ii] then
				local _, special = GetSpellBookItemInfo(i, BOOKTYPE_SPELL);	
				table.insert(Skill_List_ON,special)
			end
		end
	end
	for ii=1, #Skill_List_1 do
		for i=tabOffset + 1, tabOffset + numEntries do
			local spellName, _ = GetSpellBookItemName(i, BOOKTYPE_SPELL)
			if spellName==Skill_List_1[ii] then
				local _, special = GetSpellBookItemInfo(i, BOOKTYPE_SPELL);	
				table.insert(Skill_List_1_ON,special)
			end
		end
	end
end
--专业界面扩展/////////////////////////////////////////////
local function TradeSkillFunc()
	if TRADE_SKILLS_DISPLAYED==8 then
		UIPanelWindows["TradeSkillFrame"] = {area = "override", pushable = 1, xoffset = -16, yoffset = 12, bottomClampOverride = 140 + 12, width = 714, height = 487, whileDead = 1}	
		TradeSkillFrame:SetWidth(713)
		TradeSkillFrame:SetHeight(487)
		
		local regions = {TradeSkillFrame:GetRegions()}
		regions[2]:SetTexture("Interface\\QUESTFRAME\\UI-QuestLogDualPane-Left")
		regions[2]:SetSize(512, 512)

		regions[3]:ClearAllPoints()
		regions[3]:SetPoint("TOPLEFT", regions[2], "TOPRIGHT", 0, 0)
		regions[3]:SetTexture("Interface\\QUESTFRAME\\UI-QuestLogDualPane-Right")
		regions[3]:SetSize(256, 512)

		regions[4]:Hide()
		regions[5]:Hide()
		regions[8]:Hide()
		regions[9]:Hide()
		regions[10]:Hide()
		--隐藏全部折叠附近纹理
		TradeSkillExpandTabLeft:Hide()
		TradeSkillExpandTabRight:Hide()
		TradeSkillSkillBorderLeft:Hide()
		-- 扩展配方列表到最高
		TradeSkillListScrollFrame:ClearAllPoints()
		TradeSkillListScrollFrame:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", 25, -75)
		TradeSkillListScrollFrame:SetSize(295, 336)
		--调整配方列表底部纹理
		local RecipeInset = TradeSkillFrame:CreateTexture("RecipeInset_Tex", "ARTWORK")
		RecipeInset:SetSize(304, 361)
		RecipeInset:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", 16, -72)
		RecipeInset:SetTexture("Interface\\RAIDFRAME\\UI-RaidFrame-GroupBg")
		--配方详情移到右边增加高度
		TradeSkillDetailScrollFrame:ClearAllPoints()
		TradeSkillDetailScrollFrame:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", 352, -74)
		TradeSkillDetailScrollFrame:SetSize(298, 336)
		-- 调整配方详细页纹理
		local DetailsInset = _G["TradeSkillFrame"]:CreateTexture("DetailsInset_Tex", "ARTWORK")
		DetailsInset:SetSize(302, 339)
		DetailsInset:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", 348, -72)
		DetailsInset:SetTexture("Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-Parchment-Horizontal-Desaturated")
		-- 增加配方列表目录数
		local oldTradeSkillsDisplayed = TRADE_SKILLS_DISPLAYED
		for i = 1 + 1, TRADE_SKILLS_DISPLAYED do
			_G["TradeSkillSkill" .. i]:ClearAllPoints()
			_G["TradeSkillSkill" .. i]:SetPoint("TOPLEFT", _G["TradeSkillSkill" .. (i-1)], "BOTTOMLEFT", 0, 1)
		end
		_G.TRADE_SKILLS_DISPLAYED = _G.TRADE_SKILLS_DISPLAYED + 14
		for i = oldTradeSkillsDisplayed + 1, TRADE_SKILLS_DISPLAYED do
			local button = CreateFrame("Button", "TradeSkillSkill" .. i, TradeSkillFrame, "TradeSkillSkillButtonTemplate")
			button:SetID(i)
			button:Hide()
			button:ClearAllPoints()
			button:SetPoint("TOPLEFT", _G["TradeSkillSkill" .. (i-1)], "BOTTOMLEFT", 0, 1)
		end
		--选中高亮条宽度
		hooksecurefunc(_G["TradeSkillHighlightFrame"], "Show", function()
			_G["TradeSkillHighlightFrame"]:SetWidth(290)
		end)
		--技能点数条位置
		TradeSkillRankFrame:ClearAllPoints()
		TradeSkillRankFrame:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", 84, -46)
		--调整关闭按钮位置
		TradeSkillCancelButton:SetSize(80, 22)
		TradeSkillCancelButton:ClearAllPoints()
		TradeSkillCancelButton:SetPoint("BOTTOMRIGHT", TradeSkillFrame, "BOTTOMRIGHT", -42, 54)
		--调整全部制造按钮位置
		TradeSkillCreateButton:ClearAllPoints()
		TradeSkillCreateButton:SetPoint("RIGHT", TradeSkillCancelButton, "LEFT", -1, 0)
		--分类下拉菜单位置
		TradeSkillInvSlotDropDown:ClearAllPoints()
		TradeSkillInvSlotDropDown:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", 498, -40)
		---
		for F=1, #Skill_List_1_ON do
			local Skill_Button_D = CreateFrame("Button", "Skill_Button_D_"..Skill_List_1_ON[F].."_UI", TradeSkillFrame, "SecureActionButtonTemplate");
			local _, _, icon = GetSpellInfo(Skill_List_1_ON[F]);
			Skill_Button_D:SetNormalTexture(icon);
			Skill_Button_D:SetHighlightTexture(130718);
			Skill_Button_D:SetSize(Width,Height);
			Skill_Button_D:ClearAllPoints()
			if F==1 then
				Skill_Button_D:SetPoint("BOTTOMLEFT",TradeSkillFrame,"BOTTOMRIGHT",-32,64);
			else
				Skill_Button_D:SetPoint("BOTTOM",_G["Skill_Button_D_"..Skill_List_1_ON[F-1].."_UI"],"TOP",0,16);
			end
			Skill_Button_D:RegisterForClicks("AnyUp");
			Skill_Button_D:SetAttribute("type", "spell");
			Skill_Button_D:SetAttribute("spell", Skill_List_1_ON[F]);

			local Skill_Button_D_Border = Skill_Button_D:CreateTexture("Skill_Button_D_Border_"..Skill_List_1_ON[F].."_UI", "BORDER");
			Skill_Button_D_Border:SetTexture(136831);
			Skill_Button_D_Border:SetSize(Width*1.9,Height*1.9);
			Skill_Button_D_Border:ClearAllPoints();
			Skill_Button_D_Border:SetPoint("TOPLEFT",Skill_Button_D,"TOPLEFT",-Width*0.1,Height*0.32);

			local Skill_Button_D_Down = Skill_Button_D:CreateTexture("Skill_Button_D_Down_"..Skill_List_1_ON[F].."_UI", "OVERLAY");
			Skill_Button_D_Down:SetTexture(130839);
			Skill_Button_D_Down:SetAllPoints(Skill_Button_D)
			Skill_Button_D_Down:Hide();
			_G["Skill_Button_D_"..Skill_List_1_ON[F].."_UI"]:SetScript("OnMouseDown", function ()
				_G["Skill_Button_D_Down_"..Skill_List_1_ON[F].."_UI"]:Show();
			end);
			_G["Skill_Button_D_"..Skill_List_1_ON[F].."_UI"]:SetScript("OnMouseUp", function ()
				_G["Skill_Button_D_Down_"..Skill_List_1_ON[F].."_UI"]:Hide();
			end);

			local Skill_Button_D_START = Skill_Button_D:CreateTexture("Skill_Button_D_START_"..Skill_List_1_ON[F].."_UI", "OVERLAY");
			Skill_Button_D_START:SetTexture(130724);
			Skill_Button_D_START:SetBlendMode("ADD");
			Skill_Button_D_START:SetAllPoints(Skill_Button_D)
			Skill_Button_D_START:Hide();
		end
		for F=1, #Skill_List_ON do
			local Skill_Button = CreateFrame("Button", "Skill_Button_"..Skill_List_ON[F].."_UI", TradeSkillFrame, "SecureActionButtonTemplate");
			local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(Skill_List_ON[F]);
			Skill_Button:SetNormalTexture(icon);
			Skill_Button:SetHighlightTexture(130718);
			Skill_Button:SetSize(Width,Height);
			Skill_Button:ClearAllPoints()
			if F==1 then
				Skill_Button:SetPoint("TOPLEFT",TradeSkillFrame,"TOPRIGHT",-32,-46);
			else
				Skill_Button:SetPoint("TOP", _G["Skill_Button_"..Skill_List_ON[F-1].."_UI"], "BOTTOM", 0, -16);
			end
			Skill_Button:RegisterForClicks("AnyUp");
			Skill_Button:SetAttribute("type", "spell");
			Skill_Button:SetAttribute("spell", Skill_List_ON[F]);
			-----------
			local Skill_Button_Border = Skill_Button:CreateTexture("Skill_Button_Border_"..Skill_List_ON[F].."_UI", "BORDER");
			Skill_Button_Border:SetTexture(136831);
			Skill_Button_Border:SetSize(Width*1.9,Height*1.9);
			Skill_Button_Border:ClearAllPoints();
			Skill_Button_Border:SetPoint("TOPLEFT",Skill_Button,"TOPLEFT",-Width*0.1,Height*0.32);

			local Skill_Button_Down = Skill_Button:CreateTexture("Skill_Button_Down_"..Skill_List_ON[F].."_UI", "OVERLAY");
			Skill_Button_Down:SetTexture(130839);
			Skill_Button_Down:SetAllPoints(Skill_Button)
			Skill_Button_Down:Hide();
			_G["Skill_Button_"..Skill_List_ON[F].."_UI"]:SetScript("OnMouseDown", function ()
				_G["Skill_Button_Down_"..Skill_List_ON[F].."_UI"]:Show();
			end);
			_G["Skill_Button_"..Skill_List_ON[F].."_UI"]:SetScript("OnMouseUp", function ()
				_G["Skill_Button_Down_"..Skill_List_ON[F].."_UI"]:Hide();
			end);
			local Skill_Button_START = Skill_Button:CreateTexture("Skill_Button_START_"..Skill_List_ON[F].."_UI", "OVERLAY");
			Skill_Button_START:SetTexture(130724);
			Skill_Button_START:SetBlendMode("ADD");
			Skill_Button_START:SetAllPoints(Skill_Button)
			Skill_Button_START:Hide();
		end
		TradeSkillFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED","player");
		TradeSkillFrame:RegisterEvent("UNIT_SPELLCAST_START","player");
		TradeSkillFrame:RegisterEvent("UNIT_SPELLCAST_STOP","player");
		TradeSkillFrame:HookScript("OnEvent", function(self,event,arg1,arg2,arg3)
			if event=="UNIT_SPELLCAST_SUCCEEDED" then
				for f=1, #Skill_List_ON do
					if arg3==Skill_List_ON[f] then
						for ff=1, #Skill_List_ON do
							_G["Skill_Button_START_"..Skill_List_ON[ff].."_UI"]:Hide();
						end
						_G["Skill_Button_START_"..arg3.."_UI"]:Show();
						local function xianshifumjihuo() 
							if CraftFrame then
								_G["Craft_Button_START_"..arg3.."_UI"]:Show() 
							end
						end
						C_Timer.After(0.4,xianshifumjihuo);
					end
				end
			end
			if event=="UNIT_SPELLCAST_START" then
				for f=1, #Skill_List_ON do
					if arg3==Skill_List_ON[f] then
						_G["Skill_Button_D_START_"..arg3.."_UI"]:Show();
					end
				end
			end
			if event=="UNIT_SPELLCAST_STOP" then
				for f=1, #Skill_List_ON do
					if arg3==Skill_List_ON[f] then
						_G["Skill_Button_D_START_"..arg3.."_UI"]:Hide();
					end
				end
			end
		end)
	end
end
--附魔框架扩展/////////////////////////////////////////////
local function CraftFunc()
	if CRAFTS_DISPLAYED==8 then  
		UIPanelWindows["CraftFrame"] = {area = "override", pushable = 1, xoffset = -16, yoffset = 12, bottomClampOverride = 140 + 12, width = 714, height = 487, whileDead = 1}
		--重新设置附魔框架大小
		CraftFrame:SetWidth(713)
		CraftFrame:SetHeight(487)
		--纹理调整替换
		local regions = {_G["CraftFrame"]:GetRegions()}
		regions[2]:SetTexture("Interface\\QUESTFRAME\\UI-QuestLogDualPane-Left")
		regions[2]:SetSize(512, 512)
		regions[3]:ClearAllPoints()
		regions[3]:SetPoint("TOPLEFT", regions[2], "TOPRIGHT", 0, 0)
		regions[3]:SetTexture("Interface\\QUESTFRAME\\UI-QuestLogDualPane-Right")
		regions[3]:SetSize(256, 512)
		regions[4]:Hide()
		regions[5]:Hide()
		regions[9]:Hide()
		regions[10]:Hide()
		CraftSkillBorderLeft:SetAlpha(0)
		CraftSkillBorderRight:SetAlpha(0)
		--技能点数条位置
		CraftRankFrame:ClearAllPoints()
		CraftRankFrame:SetPoint("TOPLEFT", CraftFrame, "TOPLEFT", 84, -46)
		
		-- 附魔框架标题位置
		CraftFrameTitleText:ClearAllPoints()
		CraftFrameTitleText:SetPoint("TOP", CraftFrame, "TOP", 0, -18)

		-- 附魔列表增加高度
		CraftListScrollFrame:ClearAllPoints()
		CraftListScrollFrame:SetPoint("TOPLEFT", CraftFrame, "TOPLEFT", 25, -75)
		CraftListScrollFrame:SetSize(295, 336)

		-- 增加附魔目录可显示数
		local oldCraftsDisplayed = CRAFTS_DISPLAYED
		Craft1Cost:ClearAllPoints()
		Craft1Cost:SetPoint("RIGHT", Craft1, "RIGHT", -30, 0)
		for i = 1 + 1, CRAFTS_DISPLAYED do
			_G["Craft" .. i]:ClearAllPoints()
			_G["Craft" .. i]:SetPoint("TOPLEFT", _G["Craft" .. (i-1)], "BOTTOMLEFT", 0, 1)
			_G["Craft" .. i .. "Cost"]:ClearAllPoints()
			_G["Craft" .. i .. "Cost"]:SetPoint("RIGHT", _G["Craft" .. i], "RIGHT", -30, 0)
		end
		_G.CRAFTS_DISPLAYED = _G.CRAFTS_DISPLAYED + 14
		for i = oldCraftsDisplayed + 1, CRAFTS_DISPLAYED do
			local button = CreateFrame("Button", "Craft" .. i, CraftFrame, "CraftButtonTemplate")
			button:SetID(i)
			button:Hide()
			button:ClearAllPoints()
			button:SetPoint("TOPLEFT", _G["Craft" .. (i-1)], "BOTTOMLEFT", 0, 1)
			_G["Craft" .. i .. "Cost"]:ClearAllPoints()
			_G["Craft" .. i .. "Cost"]:SetPoint("RIGHT", _G["Craft" .. i], "RIGHT", -30, 0)
		end
		
		-- 选中高亮条宽度
		hooksecurefunc(_G["CraftHighlightFrame"], "Show", function()
			_G["CraftHighlightFrame"]:SetWidth(290)
		end)
		-- 附魔材料细节移到右边增加高度
		CraftDetailScrollFrame:ClearAllPoints()
		CraftDetailScrollFrame:SetPoint("TOPLEFT", CraftFrame, "TOPLEFT", 352, -74)
		CraftDetailScrollFrame:SetSize(298, 336)
		-- 细节滚动条隐藏
		CraftDetailScrollFrameTop:SetAlpha(0)
		CraftDetailScrollFrameBottom:SetAlpha(0)
		
		-- 替换左侧列表纹理
		local RecipeInset = CraftFrame:CreateTexture(nil, "ARTWORK")
		RecipeInset:SetSize(304, 361)
		RecipeInset:SetPoint("TOPLEFT", CraftFrame, "TOPLEFT", 16, -72)
		RecipeInset:SetTexture("Interface\\RAIDFRAME\\UI-RaidFrame-GroupBg")
		-- 右侧底部纹理
		local DetailsInset = CraftFrame:CreateTexture(nil, "ARTWORK")
		DetailsInset:SetSize(302, 339)
		DetailsInset:SetPoint("TOPLEFT", CraftFrame, "TOPLEFT", 348, -72)
		DetailsInset:SetTexture("Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-Parchment-Horizontal-Desaturated")
		
		-- 关闭按钮位置
		CraftCancelButton:SetSize(80, 22)
		CraftCancelButton:SetText(CLOSE)
		CraftCancelButton:ClearAllPoints()
		CraftCancelButton:SetPoint("BOTTOMRIGHT", CraftFrame, "BOTTOMRIGHT", -42, 54)
		-- 附魔按钮
		CraftCreateButton:ClearAllPoints()
		CraftCreateButton:SetPoint("RIGHT", CraftCancelButton, "LEFT", -1, 0)
		
		-- 训练宠物
		CraftFramePointsLabel:ClearAllPoints()
		CraftFramePointsLabel:SetPoint("TOPLEFT", CraftFrame, "TOPLEFT", 500, -46)
		CraftFramePointsText:ClearAllPoints()
		CraftFramePointsText:SetPoint("LEFT", CraftFramePointsLabel, "RIGHT", 3, 0)

		--创建按钮
		for F=1, #Skill_List_1_ON do
			local Craft_Button_D = CreateFrame("Button", "Craft_Button_D_"..Skill_List_1_ON[F].."_UI", CraftFrame, "SecureActionButtonTemplate");
			local _, _, icon = GetSpellInfo(Skill_List_1_ON[F]);
			Craft_Button_D:SetNormalTexture(icon);
			Craft_Button_D:SetHighlightTexture(130718);
			Craft_Button_D:SetSize(Width,Height);
			Craft_Button_D:ClearAllPoints()
			if F==1 then
				Craft_Button_D:SetPoint("BOTTOMLEFT",CraftFrame,"BOTTOMRIGHT",-32,64);
			else
				Craft_Button_D:SetPoint("BOTTOM",_G["Craft_Button_D_"..Skill_List_1_ON[F-1].."_UI"],"TOP",0,16);
			end
			Craft_Button_D:RegisterForClicks("AnyUp");
			Craft_Button_D:SetAttribute("type", "spell");
			Craft_Button_D:SetAttribute("spell", Skill_List_1_ON[F]);

			local Craft_Button_D_Border = Craft_Button_D:CreateTexture("Craft_Button_D_Border_"..Skill_List_1_ON[F].."_UI", "BORDER");
			Craft_Button_D_Border:SetTexture(136831);
			Craft_Button_D_Border:SetSize(Width*1.9,Height*1.9);
			Craft_Button_D_Border:ClearAllPoints();
			Craft_Button_D_Border:SetPoint("TOPLEFT",Craft_Button_D,"TOPLEFT",-Width*0.1,Height*0.32);

			local Craft_Button_D_Down = Craft_Button_D:CreateTexture("Craft_Button_D_Down_"..Skill_List_1_ON[F].."_UI", "OVERLAY");
			Craft_Button_D_Down:SetTexture(130839);
			Craft_Button_D_Down:SetAllPoints(Craft_Button_D)
			Craft_Button_D_Down:Hide();
			_G["Craft_Button_D_"..Skill_List_1_ON[F].."_UI"]:SetScript("OnMouseDown", function ()
				_G["Craft_Button_D_Down_"..Skill_List_1_ON[F].."_UI"]:Show();
			end);
			_G["Craft_Button_D_"..Skill_List_1_ON[F].."_UI"]:SetScript("OnMouseUp", function ()
				_G["Craft_Button_D_Down_"..Skill_List_1_ON[F].."_UI"]:Hide();
			end);

			local Craft_Button_D_START = Craft_Button_D:CreateTexture("Craft_Button_D_START_"..Skill_List_1_ON[F].."_UI", "OVERLAY");
			Craft_Button_D_START:SetTexture(130724);
			Craft_Button_D_START:SetBlendMode("ADD");
			Craft_Button_D_START:SetAllPoints(Craft_Button_D)
			Craft_Button_D_START:Hide();
		end
		for F=1, #Skill_List_ON do
			local Craft_Button = CreateFrame("Button", "Craft_Button_"..Skill_List_ON[F].."_UI", CraftFrame, "SecureActionButtonTemplate");
			local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(Skill_List_ON[F]);
			Craft_Button:SetNormalTexture(icon);
			Craft_Button:SetHighlightTexture(130718);
			Craft_Button:SetSize(Width,Height);
			Craft_Button:ClearAllPoints()
			if F==1 then
				Craft_Button:SetPoint("TOPLEFT",CraftFrame,"TOPRIGHT",-32,-46);
			else
				Craft_Button:SetPoint("TOP", _G["Craft_Button_"..Skill_List_ON[F-1].."_UI"], "BOTTOM", 0, -16);
			end
			Craft_Button:RegisterForClicks("AnyUp");
			Craft_Button:SetAttribute("type", "spell");
			Craft_Button:SetAttribute("spell", Skill_List_ON[F]);
			-----------
			local Craft_Button_Border = Craft_Button:CreateTexture("Craft_Button_Border_"..Skill_List_ON[F].."_UI", "BORDER");
			Craft_Button_Border:SetTexture(136831);
			Craft_Button_Border:SetSize(Width*1.9,Height*1.9);
			Craft_Button_Border:ClearAllPoints();
			Craft_Button_Border:SetPoint("TOPLEFT",Craft_Button,"TOPLEFT",-Width*0.1,Height*0.32);

			local Craft_Button_Down = Craft_Button:CreateTexture("Craft_Button_Down_"..Skill_List_ON[F].."_UI", "OVERLAY");
			Craft_Button_Down:SetTexture(130839);
			Craft_Button_Down:SetAllPoints(Craft_Button)
			Craft_Button_Down:Hide();
			_G["Craft_Button_"..Skill_List_ON[F].."_UI"]:SetScript("OnMouseDown", function ()
				_G["Craft_Button_Down_"..Skill_List_ON[F].."_UI"]:Show();
			end);
			_G["Craft_Button_"..Skill_List_ON[F].."_UI"]:SetScript("OnMouseUp", function ()
				_G["Craft_Button_Down_"..Skill_List_ON[F].."_UI"]:Hide();
			end);
			local Craft_Button_START = Craft_Button:CreateTexture("Craft_Button_START_"..Skill_List_ON[F].."_UI", "OVERLAY");
			Craft_Button_START:SetTexture(130724);
			Craft_Button_START:SetBlendMode("ADD");
			Craft_Button_START:SetAllPoints(Craft_Button)
			Craft_Button_START:Hide();
		end
		--
		CraftFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED","player");
		CraftFrame:RegisterEvent("UNIT_SPELLCAST_START","player");
		CraftFrame:RegisterEvent("UNIT_SPELLCAST_STOP","player");
		CraftFrame:HookScript("OnEvent", function(self,event,arg1,arg2,arg3)
			if event=="UNIT_SPELLCAST_SUCCEEDED" then
				for f=1, #Skill_List_ON do
					if arg3==Skill_List_ON[f] then
						for ff=1, #Skill_List_ON do
							_G["Craft_Button_START_"..Skill_List_ON[ff].."_UI"]:Hide();
						end
						_G["Craft_Button_START_"..arg3.."_UI"]:Show();
					end
				end	
			end
			if event=="UNIT_SPELLCAST_START" then
				for f=1, #Skill_List_1_ON do
					if arg3==Skill_List_1_ON[f] then
						_G["Craft_Button_D_START_"..arg3.."_UI"]:Show();
					end
				end
			end
			if event=="UNIT_SPELLCAST_STOP" then
				for f=1, #Skill_List_1_ON do
					if arg3==Skill_List_1_ON[f] then
						_G["Craft_Button_D_START_"..arg3.."_UI"]:Hide();
					end
				end
			end
		end)
	end
end
-------
local function ZhuanyeFrame_Open()
	if IsAddOnLoaded("Blizzard_TradeSkillUI") then
		Skilllaqu()
		TradeSkillFunc()
	else
		local zhuanyeFrame = CreateFrame("FRAME")
		zhuanyeFrame:RegisterEvent("ADDON_LOADED")
		zhuanyeFrame:SetScript("OnEvent", function(self, event, arg1)
			if arg1 == "Blizzard_TradeSkillUI" then
				Skilllaqu()
				TradeSkillFunc()
				zhuanyeFrame:UnregisterEvent("ADDON_LOADED")
			end
		end)
	end
	if IsAddOnLoaded("Blizzard_CraftUI") then
		Skilllaqu()
		CraftFunc();
	else
		local fumoFrame = CreateFrame("FRAME")
		fumoFrame:RegisterEvent("ADDON_LOADED")
		fumoFrame:SetScript("OnEvent", function(self, event, arg1)
			if arg1 == "Blizzard_CraftUI" then
				Skilllaqu()
				CraftFunc();
				fumoFrame:UnregisterEvent("ADDON_LOADED")
			end
		end)
	end
end
-----------------------
fuFrame.Zhuanye = CreateFrame("CheckButton", nil, fuFrame, "ChatConfigCheckButtonTemplate");
fuFrame.Zhuanye:SetSize(30,32);
fuFrame.Zhuanye:SetPoint("TOPLEFT",fuFrame,"TOPLEFT",300,-80);
fuFrame.Zhuanye.Text:SetText("专业界面扩展");
fuFrame.Zhuanye.tooltip = "1、扩展专业技能界面为两列；左边配方列表，右边配方详情。\n2、并在专业界面右侧显示便捷切换专业按钮！";
fuFrame.Zhuanye:SetScript("OnClick", function (self)
	if self:GetChecked() then
		PIG['FramePlus']['ExtFrame_Zhuanye']="ON";
		ZhuanyeFrame_Open();
	else
		PIG['FramePlus']['ExtFrame_Zhuanye']="OFF";
		Pig_Options_RLtishi_UI:Show()
	end
end);

--=====================================
addonTable.FramePlus_ExtFrame = function()
	if PIG['FramePlus']['ExtFrame_Renwu']=="ON" then
		fuFrame.Renwu:SetChecked(true);
		RenwuFrame_Open();
	end
	if PIG['FramePlus']['ExtFrame_Zhuanye']=="ON" then
		fuFrame.Zhuanye:SetChecked(true);
		ZhuanyeFrame_Open();
	end
end